/*
 * Created on 08.12.2004
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2520 $
 *  $Date: 2006-10-11 12:07:12 +0200 (Mi, 11 Okt 2006) $
 *  $Id: FeatureSelectingPlugIn.java 2520 2006-10-11 10:07:12Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.plugIns;

import java.awt.Color;
import java.awt.Shape;
import java.util.List;
import java.util.Map;

import com.vividsolutions.jump.feature.Feature;
import com.vividsolutions.jump.util.Range;
import com.vividsolutions.jump.workbench.model.Layer;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.workbench.ui.LayerViewPanel;
import com.vividsolutions.jump.workbench.ui.renderer.style.BasicStyle;
import com.vividsolutions.jump.workbench.ui.renderer.style.ColorThemingStyle;

import de.fhOsnabrueck.jump.pirol.utilities.FeatureSelector;
import de.fhOsnabrueck.jump.pirol.utilities.apiTools.FeatureCollectionTools;
import de.fhOsnabrueck.jump.pirol.utilities.colors.ColorGenerator;
import de.fhOsnabrueck.jump.pirol.utilities.debugOutput.DebugUserIds;
import de.fhOsnabrueck.jump.pirol.utilities.debugOutput.PersonalLogger;
import de.fhOsnabrueck.jump.pirol.utilities.diagrams.InterativeDiagram;
import de.fhOsnabrueck.jump.pirol.utilities.diagrams.diagramCalculator;

/**
 * 
 * TODO: comment class
 *
 * <br><br><b>Last change by $Author: LBST-PF-3\orahn $ on $Date: 2006-10-11 12:07:12 +0200 (Mi, 11 Okt 2006) $</b>
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2006),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2520 $
 *
 */
public abstract class FeatureSelectingPlugIn extends StandardPirolPlugIn implements FeatureSelector {
	protected int numCathegory = 0;
	
	protected PlugInContext context = null;
	protected LayerViewPanel layerViewPanel = null;
	
	protected Layer resultLayer = null;
	protected Layer layer = null;
	
	protected ColorGenerator colorGenerator = null;

	protected BasicStyle basicStyle = new BasicStyle(Color.yellow);
	
	protected boolean active = false;
	
	protected InterativeDiagram diagramm = null;
	
	protected diagramCalculator calculator = null;
    
    protected String iconFileName = null; 
	
	public FeatureSelectingPlugIn(String iconString){
		super(new PersonalLogger(DebugUserIds.OLE));
        this.iconFileName = iconString;
	}

    public String getIconString() {
        return this.iconFileName;
    }

    protected Shape getShape() throws Exception {
		// no shapes there...
		return null;
	}
	
	protected static Feature getFeatureFromCollection( List<Feature> features, int fid ){
		return FeatureCollectionTools.getFeatureFromCollection( features, fid );		
	}
	

	protected void makeColorArray( int numKat ){
		
	    this.colorGenerator = ColorGenerator.getTrafficLightColors(numKat);

	}
	
	public abstract void selectFeatures(List features, int kat);
	
	protected void identifyFeaturesInLayer( Layer layer, String Attribute, Object value, Color color){
		BasicStyle bs = new BasicStyle(color);
		bs.setLineColor(color);
		bs.setLineWidth(2);
		bs.setEnabled(true);

		Range.RangeTreeMap styleMap = new  Range.RangeTreeMap();
		
		styleMap.put(value,bs);
		
		Map oldMap = null;
		
		if (ColorThemingStyle.get(layer)!=null){
			oldMap = ColorThemingStyle.get(layer).getAttributeValueToBasicStyleMap();
			layer.removeStyle(ColorThemingStyle.get(layer));
		}
		
		if (oldMap != null){
			styleMap.putAll(oldMap);
		}
		
		ColorThemingStyle cts = null;
		
		cts = new ColorThemingStyle(Attribute, styleMap,this.basicStyle);
		
		cts.setAttributeName(Attribute);
		
		layer.getBasicStyle().setEnabled(false);
		cts.setEnabled(true);	
		layer.addStyle(cts);
		
		if (!cts.isEnabled())
			cts.setEnabled(true);
		
		if (!layer.isVisible()){
			layer.setVisible(true);
		}
	}
    
    public static Feature[] getFeaturesInFenceOrInLayer(PlugInContext context,Layer layer){
        return StandardPirolPlugIn.getFeaturesInFenceOrInLayer(context, layer);
    }
    
    

}
